// This autogenerated skeleton file illustrates how to build a server.
// You should copy it to another filename to avoid overwriting it.

#include "ChatService.h"
#include <thrift/protocol/TBinaryProtocol.h>
#include <thrift/server/TSimpleServer.h>
#include <thrift/transport/TServerSocket.h>
#include <thrift/transport/TBufferTransports.h>

using namespace ::apache::thrift;
using namespace ::apache::thrift::protocol;
using namespace ::apache::thrift::transport;
using namespace ::apache::thrift::server;

using boost::shared_ptr;

using namespace  ::chatgen;

class ChatServiceHandler : virtual public ChatServiceIf {
 public:
  ChatServiceHandler() {
    // Your initialization goes here
  }

  void Connect(const std::string& userName) {
    // Your implementation goes here
    printf("Connect\n");
  }

  void Ping() {
    // Your implementation goes here
    printf("Ping\n");
  }

  void Disconnect() {
    // Your implementation goes here
    printf("Disconnect\n");
  }

  void GetUserList(std::set<std::string> & _return) {
    // Your implementation goes here
    printf("GetUserList\n");
  }

  void SendDirectMessage(const std::string& message, const std::string& toUserName) {
    // Your implementation goes here
    printf("SendDirectMessage\n");
  }

  void SendBroadcastMessage(const std::string& message) {
    // Your implementation goes here
    printf("SendBroadcastMessage\n");
  }

};

int main(int argc, char **argv) {
  int port = 9090;
  shared_ptr<ChatServiceHandler> handler(new ChatServiceHandler());
  shared_ptr<TProcessor> processor(new ChatServiceProcessor(handler));
  shared_ptr<TServerTransport> serverTransport(new TServerSocket(port));
  shared_ptr<TTransportFactory> transportFactory(new TBufferedTransportFactory());
  shared_ptr<TProtocolFactory> protocolFactory(new TBinaryProtocolFactory());

  TSimpleServer server(processor, serverTransport, transportFactory, protocolFactory);
  server.serve();
  return 0;
}

